local player_pos = 9999

UI.setBts    = function() end
UI.clearPosBts = function() end

MW.timerFun = function ()  
 
  local pos = renoise.song().transport.playback_pos 

  if (pos.line ~= player_pos) then  

    player_pos = pos.line

    if player_pos == 1 and MW.grab_auto and MW.edit_RN_phrase == false then -------- auto grab
      grabNotes()
      return
    end

    if player_pos == Rand.auto_line and MW.edit_RN_phrase == false then -------------- randomization
      -- sprint('Apply at line ' .. pos.line) end
             
      for k,v in ipairs(Rand.auto_tb) do 
        if v then
          if k == 1 and Rand.lib_preset then
            UI.lib_pu.value = math.random(#Scan.files) 
          else       
            UI.menu[k].fun()
          end
        end
      end       
    end

    if CH2P.reapply > 0 and player_pos%CH2P.reapply == 1 and MW.edit_RN_phrase == false then
      sprint('Harmoize trigged at line ' .. player_pos)
      harmonizePhraseApply() 
    end
        
    if (MW.phr.editor_name == "Arpeggiator") then
      if Arp.player_pos[player_pos] then
        local arp_n = Arp.player_pos[player_pos].arp_n
        local arp_form = Arp.player_pos[player_pos].arp_form
        
        if (Arp.form_no == arp_form) then
        
          for i=1,#Arp.ui_rows do
            Arp.ui_rows[i].style = 'invisible'
          end
          
          Arp.ui_rows[arp_n].style = 'plain'
        end
                 
      end
    end

--------------------------- update buttons
 
    if MW.phr.editor_pattern then     -- pattern 
      
      if UI.last_used_editor_was_stepN then   
        local pat_pos_in_editor = MW.timer_pos2[player_pos]  
        
        if pat_pos_in_editor == nil then return end   --print('timer ' .. pat_pos_in_editor)
        
        MW.player_pos = pat_pos_in_editor
        
        if UI.setBts(player_pos) then 
          UI.setBts = function() end
        end
print('UI.editor_bts') rprint(UI.editor_bts)  print('pat_pos_in_editor  ' .. pat_pos_in_editor)
        if pat_pos_in_editor and pat_pos_in_editor > 0 and UI.editor_bts[pat_pos_in_editor] then 
          for _,v in ipairs(UI.editor_bts[pat_pos_in_editor]) do
            v.color = {64,64,64}  
          end
          
          for _,v in pairs(UI.editor_bts[pat_pos_in_editor].patN_notes_ix) do
            UI.editor_bts[pat_pos_in_editor][v].color = {255,255,255}
          end
          
          UI.setBts = function (current_pat_pos) 
           
            if not UI.last_used_editor_was_stepN or pat_pos_in_editor == current_pat_pos then return false end 
  
            for _,v in ipairs(UI.editor_bts[pat_pos_in_editor]) do
              v.color = {1,1,1}  
            end
          
            for _,v in pairs(UI.editor_bts[pat_pos_in_editor].patN_notes_ix) do
              UI.editor_bts[pat_pos_in_editor][v].color = {255,255,255}
            end            
           
            return true
          end 
        end      
        
      else  
              
        if UI.setBts(player_pos) then 
          UI.setBts = function() end
        end
        
        if player_pos <= MW.seq_length and UI.editor_bts[player_pos] then                 
                    
          for _,v in ipairs(UI.editor_bts[player_pos]) do
            v.color = {64,64,64} 
          end
         
          for _,v in pairs(UI.editor_bts[player_pos].pat_notes_ix) do
            UI.editor_bts[player_pos][v].color = {255,255,255}
          end
          
          local pos = player_pos
          
          UI.setBts = function (current_pat_pos)
           
            if  not MW.phr.editor_pattern or UI.last_used_editor_was_stepN or pos == current_pat_pos then return false end
            
            MW.phr.lpb = setLPB()
            local bg_col = {1,1,1}
            if member (pos,MW.phr.lpb) then -- (member (pos,MW.phr.lpb) and MW.phr.editor_pattern and MW.phr.editor_pattern_N == false) then      
              bg_col = {30, 30, 30}
            end
            
            if pos%16 == 1 then
              bg_col = {45, 45, 45}
            end
  
            for _,v in ipairs(UI.editor_bts[pos]) do
              v.color = bg_col
            end
          
            for _,v in pairs(UI.editor_bts[pos].pat_notes_ix) do
              UI.editor_bts[pos][v].color = {255,255,255}
            end            
           
            return true
          end 
          
        end
      end
    
    else  -- vbox 
      local player_pos_in_editor = nil
      
      if (MW.phr.editor_pattern == false) then  
        player_pos_in_editor = MW.timer_pos[player_pos]  
        MW.player_pos = player_pos_in_editor
        
        if (player_pos_in_editor and UI.insert_pos_bts[player_pos_in_editor]) then
          if (player_pos_in_editor > MW.seq_length) then
            player_pos_in_editor = MW.seq_length
          end  
          
          UI.clearPosBts(player_pos_in_editor)
          
          UI.insert_pos_bts[player_pos_in_editor].color  = {255,255,255} 
          
          UI.clearPosBts = function(current_pat_pos)
            if player_pos_in_editor == current_pat_pos then return false end 
            
            UI.insert_pos_bts[player_pos_in_editor].color  = {1,1,1} 
          end          
        end 
      end

      if UI.setBts(player_pos) then 
        UI.setBts = function() end
      end
      
      
      if player_pos_in_editor ~= nil then
        if player_pos_in_editor > MW.seq_length then
          player_pos_in_editor = MW.seq_length
        end       

        if MW.phr.editor_name == 'Tonnetz' and UI.editor_bts[player_pos_in_editor].notes_pos then
          local clr = false 
          
          for _,v in pairs(UI.editor_bts[player_pos_in_editor].notes_pos) do
            if UI.editor_bts[player_pos_in_editor].tonnetz[v.y][v.x].color[1] == 255 then
            
              UI.editor_bts[player_pos_in_editor].tonnetz[v.y][v.x].color = {128,128,128}
              
              clr = true
            end
         end 
          
         if clr then
         
           UI.setBts = function (current_pat_pos)
           
             if not MW.phr.editor_chords or player_pos_in_editor == current_pat_pos then return false end
              
             for _,v in pairs(UI.editor_bts[player_pos_in_editor].notes_pos) do
               if UI.editor_bts[player_pos_in_editor].tonnetz[v.y][v.x].color[1] == 128 then
                
                 UI.editor_bts[player_pos_in_editor].tonnetz[v.y][v.x].color = {255,255,255}
               end
             end 
           end           
           return true
         end 
         
        elseif MW.phr.editor_name == 'Chords' or MW.phr.editor_name == 'Arpeggiator' and UI.editor_bts[player_pos_in_editor].notes_ix then
          local clr = false 
           
          for _,v in pairs(UI.editor_bts[player_pos_in_editor].notes_ix) do          
            if UI.editor_bts[player_pos_in_editor][v].color[1] == 255 then 
            
              UI.editor_bts[player_pos_in_editor][v].color =  {128,128,128} 
              
              clr = true 
            end
          end 

          if clr then
         
           UI.setBts = function (current_pat_pos) 
           
             if not MW.phr.editor_chords or player_pos_in_editor == current_pat_pos then return false end
               
               for _,v in pairs(UI.editor_bts[player_pos_in_editor].notes_ix) do          
                 if UI.editor_bts[player_pos_in_editor][v].color[1] == 128 then   
                   UI.editor_bts[player_pos_in_editor][v].color = {255,255,255}     
                 end
               end   
             end
             return true
           end   
        else
          local ix = UI.editor_bts[player_pos_in_editor].note_ix
          
          if ix and UI.editor_bts[player_pos_in_editor][ix].color[1] == 255 then   
            UI.editor_bts[player_pos_in_editor][ix].color = {128,128,128}     
            
            UI.setBts = function (current_pat_pos)           
              if MW.phr.editor_chords or player_pos_in_editor == current_pat_pos then return false end 
              
              if UI.editor_bts[player_pos_in_editor][ix].color[1] == 128 then 
                UI.editor_bts[player_pos_in_editor][ix].color = {255,255,255}    
              end                 
              return true
            end  
          end
        end   
      end    
    end
  end
end   

MW.setTimer = function()

 if #UI.editor_bts ==  0 then return end
 
 if renoise.tool():has_timer(MW.timerFun) then 
   return 
 else
   renoise.tool():add_timer (MW.timerFun, MW.timer)   
 end
end

MW.stopTimer = function()
   UI.setBts()
   UI.setBts = function() end 
      
  if renoise.tool():has_timer(MW.timerFun) then 
    renoise.tool():remove_timer(MW.timerFun)
  end  
end
