
----------------------------------------------- UI grab row 
function ui_grab ()

   local vb = renoise.ViewBuilder()
 
   local grab_but = vb:button {
      text = " Grab ",
      tooltip = "Setup VB, chords, arp and capture notes from currently selected track in the pattern editor or phrase editor.",
      notifier =  function ()  
        
        if MW.edit_RN_phrase then  
          local pat_con = getPatFun(MW.block_editing)  
          if (pat_con == false) then return end
       end
       
       
       MW.stopTimer()
       
       grabNotes() 
       
       MW.setTimer()
          
        if (MW.edit_RN_phrase or MW.phr.editor_chords) then
          fill(MW.phr.col)
          
          local inst_no = renoise.song().selected_instrument_index
          renoise.song().instruments[inst_no].phrase_playback_mode = 2
          renoise.song().instruments[inst_no].phrase_program = 1            
        end
      end 
    }  
    
  local grab_auto_chb = vb:checkbox {
    value = MW.grab_auto,
    tooltip = "During playback of first pattern line, capture notes from currently selected  track in the pattern editor.",
    notifier = function(value) 
      MW.grab_auto = value
    end
  }    

  local grab_seq_chb = vb:checkbox {
    value = MW.grab_seq,
    tooltip = "Capture notes from sequencer selection",
    notifier = function(value) 
      MW.grab_seq = value
    end
  }   

  local ui_grab_row = vb:row { 
    style = 'group', 
    
    grab_but,    
           
    vb:text {
      width = 15,
      text = " Auto"
    }, 
    grab_auto_chb,

    vb:text {
      width = 15,
      text = " Seq"
    }, 
    grab_seq_chb,
  }   
    
  return ui_grab_row
end

